

;//--- ID ,  35 ----------------------

SE_ASSIGNPRIMARYTOKEN_NAME     db  "SeAssignPrimaryTokenPrivilege",0
SE_AUDIT_NAME                  db  "SeAuditPrivilege",0
SE_BACKUP_NAME                 db  "SeBackupPrivilege",0
SE_CHANGE_NOTIFY_NAME          db  "SeChangeNotifyPrivilege",0
SE_CREATE_GLOBAL_NAME          db  "SeCreateGlobalPrivilege",0
SE_CREATE_PAGEFILE_NAME        db  "SeCreatePagefilePrivilege",0
SE_CREATE_PERMANENT_NAME       db  "SeCreatePermanentPrivilege",0
SE_CREATE_SYMBOLIC_LINK_NAME   db  "SeCreateSymbolicLinkPrivilege",0
SE_CREATE_TOKEN_NAME           db  "SeCreateTokenPrivilege",0
SE_DEBUG_NAME                  db  "SeDebugPrivilege",0
SE_DELEGATE_USER_IMPERSONATE   db  "SeDelegateSessionUserImpersonatePrivilege",0
SE_ENABLE_DELEGATION_NAME      db  "SeEnableDelegationPrivilege",0
SE_IMPERSONATE_NAME            db  "SeImpersonatePrivilege",0
SE_INC_BASE_PRIORITY_NAME      db  "SeIncreaseBasePriorityPrivilege",0
SE_INC_WORKING_SET_NAME        db  "SeIncreaseWorkingSetPrivilege",0
SE_INCREASE_QUOTA_NAME         db  "SeIncreaseQuotaPrivilege",0
SE_LOAD_DRIVER_NAME            db  "SeLoadDriverPrivilege",0
SE_LOCK_MEMORY_NAME            db  "SeLockMemoryPrivilege",0
SE_MACHINE_ACCOUNT_NAME        db  "SeMachineAccountPrivilege",0
SE_PROF_SINGLE_PROCESS_NAME    db  "SeProfileSingleProcessPrivilege",0
SE_RELABEL_NAME                db  "SeRelabelPrivilege",0
SE_REMOTE_SHUTDOWN_NAME        db  "SeRemoteShutdownPrivilege",0
SE_RESTORE_NAME                db  "SeRestorePrivilege",0
SE_SECURITY_NAME               db  "SeSecurityPrivilege",0
SE_SHUTDOWN_NAME               db  "SeShutdownPrivilege",0
SE_SYNC_AGENT_NAME             db  "SeSyncAgentPrivilege",0
SE_SYSTEM_ENVIRONMENT_NAME     db  "SeSystemEnvironmentPrivilege",0
SE_SYSTEM_PROFILE_NAME         db  "SeSystemProfilePrivilege",0
SE_SYSTEMTIME_NAME             db  "SeSystemtimePrivilege",0
SE_TAKE_OWNERSHIP_NAME         db  "SeTakeOwnershipPrivilege",0
SE_TCB_NAME                    db  "SeTcbPrivilege",0
SE_TIME_ZONE_NAME              db  "SeTimeZonePrivilege",0
SE_TRUSTED_CREDMAN_ACCESS_NAME db  "SeTrustedCredManAccessPrivilege",0
SE_UNDOCK_NAME                 db  "SeUndockPrivilege",0
SE_UNSOLICITED_INPUT_NAME      db  "SeUnsolicitedInputPrivilege",0

;//---   -----------------------

SE_PRIVILEGE_ENABLED_BY_DEFAULT   =  0x00000001  ;//   
SE_PRIVILEGE_ENABLED              =  0x00000002  ;//   
SE_PRIVILEGE_REMOVED              =  0x00000004  ;// 
SE_PRIVILEGE_USED_FOR_ACCESS      =  0x80000000  ;//     


;//---     LsaEnumerateAccountRights() -----
;//---   "DENY"  

SE_BATCH_LOGON_NAME                    db "SeBatchLogonRight",0
SE_DENY_BATCH_LOGON_NAME               db "SeDenyBatchLogonRight",0
SE_DENY_INTERACTIVE_LOGON_NAME         db "SeDenyInteractiveLogonRight",0
SE_DENY_NETWORK_LOGON_NAME             db "SeDenyNetworkLogonRight",0
SE_DENY_REMOTE_INTERACTIVE_LOGON_NAME  db "SeDenyRemoteInteractiveLogonRight",0
SE_DENY_SERVICE_LOGON_NAME             db "SeDenyServiceLogonRight",0 
SE_INTERACTIVE_LOGON_NAME              db "SeInteractiveLogonRight",0
SE_NETWORK_LOGON_NAME                  db "SeNetworkLogonRight",0
SE_REMOTE_INTERACTIVE_LOGON_NAME       db "SeRemoteInteractiveLogonRight",0
SE_SERVICE_LOGON_NAME                  db "SeServiceLogonRight",0


;//---    Set/Get TokenInformation() -----
;// https://docs.microsoft.com/en-us/windows/win32/api/winnt/ne-winnt-token_information_class

TokenUser                    =  1    ;// SID  (  )
TokenGroups                  =  2    ;//  SID  (  )
TokenPrivileges              =  3    ;//  LUID  (  )
TokenOwner                   =  4    ;// 
TokenPrimaryGroup            =  5    ;//    
TokenDefaultDacl             =  6    ;// DACL,     ,   
TokenSource                  =  7    ;//  ( ) ID  
TokenType                    =  8    ;// 
TokenImpersonationLevel      =  9    ;//  
TokenStatistics              =  10   ;//    
TokenRestrictedSids          =  11   ;//  SID
TokenSessionId               =  12   ;// SID  Logon
TokenGroupsAndPrivileges     =  13   
TokenSessionReference        =  14
TokenSandBoxInert            =  15
TokenAuditPolicy             =  16
TokenOrigin                  =  17
TokenElevationType           =  18
TokenLinkedToken             =  19
TokenElevation               =  20
TokenHasRestrictions         =  21
TokenAccessInformation       =  22
TokenVirtualizationAllowed   =  23
TokenVirtualizationEnabled   =  24
TokenIntegrityLevel          =  25
TokenUIAccess                =  26
TokenMandatoryPolicy         =  27
TokenLogonSid                =  28
TokenIsAppContainer          =  29
TokenCapabilities            =  30
TokenAppContainerSid         =  31
TokenAppContainerNumber      =  32
TokenUserClaimAttributes     =  33
TokenDeviceClaimAttributes   =  34
TokenRestrictedUserClaimAttributes    =  35
TokenRestrictedDeviceClaimAttributes  =  36
TokenDeviceGroups            =  37
TokenRestrictedDeviceGroups  =  38
TokenSecurityAttributes      =  39
TokenIsRestricted            =  40
TokenProcessTrustLevel       =  41
TokenPrivateNameSpace        =  42
TokenSingletonAttributes     =  43
TokenBnoIsolation            =  44
TokenChildProcessFlags       =  45
TokenIsLessPrivilegedAppContainer  =  46
TokenIsSandboxed             =  47
MaxTokenInfoClass            =  48


;//---  SID -------------

SE_GROUP_MANDATORY           =  1
SE_GROUP_ENABLED_BY_DEFAULT  =  2
SE_GROUP_ENABLED             =  4
SE_GROUP_OWNER               =  8
SE_GROUP_USE_FOR_DENY_ONLY   =  0x10
SE_GROUP_INTEGRITY           =  0x20
SE_GROUP_INTEGRITY_ENABLED   =  0x40
SE_GROUP_RESOURCE            =  0x20000000
SE_GROUP_LOGON_ID            =  0xC0000000


;//---  SECURITY_DESCRIPTOR_CONTROL
;//--- https://docs.microsoft.com/en-us/windows/win32/secauthz/security-descriptor-control

SE_OWNER_DEFAULTED           =  0x0001
SE_GROUP_DEFAULTED           =  0x0002
SE_DACL_PRESENT              =  0x0004 
SE_DACL_DEFAULTED            =  0x0008
SE_DACL_AUTO_INHERIT_REQ     =  0x0100
SE_DACL_AUTO_INHERITED       =  0x0400
SE_DACL_PROTECTED            =  0x1000
SE_RM_CONTROL_VALID          =  0x4000
SE_SACL_DEFAULTED            =  0x0008
SE_SACL_PRESENT              =  0x0010
SE_SACL_AUTO_INHERIT_REQ     =  0x0200
SE_SACL_AUTO_INHERITED       =  0x0800
SE_SACL_PROTECTED            =  0x2000
SE_SELF_RELATIVE             =  0x8000

;//----   "Rights" ( ) ------

SPECIFIC_RIGHTS_ALL        =  0x0000FFFF
DELETE                     =  0x00010000
READ_CONTROL               =  0x00020000
WRITE_DAC                  =  0x00040000
WRITE_OWNER                =  0x00080000
STANDARD_RIGHTS_REQUIRED   =  0x000F0000
SYNCHRONIZE                =  0x00100000
STANDARD_RIGHTS_ALL        =  0x001F0000
STANDARD_RIGHTS_READ       =  READ_CONTROL
STANDARD_RIGHTS_WRITE      =  READ_CONTROL
STANDARD_RIGHTS_EXECUTE    =  READ_CONTROL
GENERIC_ALL                =  0x10000000
GENERIC_EXECUTE            =  0x20000000
GENERIC_WRITE              =  0x40000000
GENERIC_READ               =  0x80000000

;//--------------------------------------------

TOKEN_ASSIGN_PRIMARY       =  0x00000001
TOKEN_DUPLICATE            =  0x00000002
TOKEN_IMPERSONATE          =  0x00000004
TOKEN_QUERY                =  0x00000008
TOKEN_QUERY_SOURCE         =  0x00000010
TOKEN_ADJUST_PRIVILEGES    =  0x00000020
TOKEN_ADJUST_DEFAULT       =  0x00000080
TOKEN_ADJUST_GROUPS        =  0x00000040
TOKEN_ADJUST_SESSIONID     =  0x00000100
TOKEN_EXECUTE              =  0x00020000
TOKEN_READ                 =  0x00020008
TOKEN_WRITE                =  0x000200E0
TOKEN_ALL_ACCESS           =  0x000201FF


;//----   ---------------

TOKEN_PRIMARY              =  1   ;// 
TOKEN_IMPERSONATION        =  2   ;//  ()

;//----   , impersonation_level
SecurityAnonymous          =  0
SecurityIdentification     =  1
SecurityImpersonation      =  2
SecurityDelegation         =  3


;//---  SID_AUTHORITY --------

SID_TYPE_USER               =  1
SID_TYPE_GROUP              =  2
SID_TYPE_DOMAIN             =  3
SID_TYPE_ALIAS              =  4  ;// 
SID_TYPE_WELLKNOWN_GROUP    =  5  ;//  
SID_TYPE_DELETED_ACCOUNT    =  6
SID_TYPE_INVALID            =  7
SID_TYPE_UNKNOWN            =  8
SID_TYPE_COMPUTER           =  9
SID_TYPE_LABEL              =  10 ;// Sid  

;//---   ACE    SD

ACCESS_ALLOWED_ACE_TYPE                   =  0x00
ACCESS_DENIED_ACE_TYPE                    =  0x01
SYSTEM_AUDIT_ACE_TYPE                     =  0x02
SYSTEM_ALARM_ACE_TYPE                     =  0x03
ACCESS_ALLOWED_COMPOUND_ACE_TYPE          =  0x04
ACCESS_ALLOWED_OBJECT_ACE_TYPE            =  0x05
ACCESS_DENIED_OBJECT_ACE_TYPE             =  0x06
SYSTEM_AUDIT_OBJECT_ACE_TYPE              =  0x07
SYSTEM_ALARM_OBJECT_ACE_TYPE              =  0x08
ACCESS_ALLOWED_CALLBACK_ACE_TYPE          =  0x09
ACCESS_DENIED_CALLBACK_ACE_TYPE           =  0x0A
ACCESS_ALLOWED_CALLBACK_OBJECT_ACE_TYPE   =  0x0B
ACCESS_DENIED_CALLBACK_OBJECT_ACE_TYPE    =  0x0C
SYSTEM_AUDIT_CALLBACK_ACE_TYPE            =  0x0D
SYSTEM_ALARM_CALLBACK_ACE_TYPE            =  0x0E
SYSTEM_AUDIT_CALLBACK_OBJECT_ACE_TYPE     =  0x0F
SYSTEM_ALARM_CALLBACK_OBJECT_ACE_TYPE     =  0x10


;//<--- GetSecurityInfo() SE_OBJECT_TYPE -----------

SE_UNKNOWN_OBJECT_TYPE	    = 0
SE_FILE_OBJECT	            = 1
SE_SERVICE	                = 2
SE_PRINTER	                = 3
SE_REGISTRY_KEY	           = 4
SE_LMSHARE	                = 5    ;//   
SE_KERNEL_OBJECT	          = 6    ;// ,    
SE_WINDOW_OBJECT	          = 7    ;//      
SE_DS_OBJECT	              = 8    ;//   
SE_DS_OBJECT_ALL	          = 9
SE_PROVIDER_DEFINED_OBJECT	= 10   ;// ,  
SE_WMIGUID_OBJECT	         = 11   ;//  WMI
SE_REGISTRY_WOW64_32KEY	   = 12   ;//      WOW64


;//<--- GetSecurityInfo() SECURITY_INFORMATION -----

OWNER_SECURITY_INFO             =  0x00000001
GROUP_SECURITY_INFO             =  0x00000002
DACL_SECURITY_INFO              =  0x00000004
SACL_SECURITY_INFO              =  0x00000008
LABEL_SECURITY_INFO             =  0x00000010
ATTRIBUTE_SECURITY_INFO         =  0x00000020   ;// Win8+
SCOPE_SECURITY_INFO             =  0x00000040   ;// Win8+
BACKUP_SECURITY_INFO            =  0x00010000   ;// Win8+
UNPROTECTED_SACL_SECURITY_INFO  =  0x10000000
UNPROTECTED_DACL_SECURITY_INFO  =  0x20000000
PROTECTED_SACL_SECURITY_INFO    =  0x40000000
PROTECTED_DACL_SECURITY_INFO    =  0x80000000


;//<--- LogonUser() --> dwLogonType  ---------------
;//-------------------------------------------------
;//        , 
;//       CreateProcessAsUser(). 
;// ,     LOGON32_LOGON_NETWORK,   , 
;//     CreateProcessAsUser(), 
;//    DuplicateTokenEx()       .

LOGON32_LOGON_INTERACTIVE       =  2  ;//     
LOGON32_LOGON_NETWORK           =  3  ;//      
LOGON32_LOGON_BATCH             =  4  ;//     (  )
LOGON32_LOGON_SERVICE           =  5  ;//      
LOGON32_LOGON_UNLOCK            =  7  ;// ..
LOGON32_LOGON_NETWORK_CLEARTEXT =  8  ;//      
LOGON32_LOGON_NEW_CREDENTIALS   =  9  ;//   -  - SID,     

LOGON32_PROVIDER_DEFAULT        =  0
LOGON32_PROVIDER_WINNT35        =  1
LOGON32_PROVIDER_WINNT40        =  2
LOGON32_PROVIDER_WINNT50        =  3

;//********************************************************************

struct SID_AND_ATTRIBUTES
  pSid             dd  0   
  Attributes       dd  0
ends

struct LUID_AND_ATTRIBUTES
  Luid             dq  0   
  Attributes       dd  0
ends

struct DACL_HEADER        ;//<------    ACL
  AclRevision      db  0  ;//  ACL_REVISION  ACL_REVISION_DS
  Sbz1             db  0  ;//    16-
  AclSize          dw  0  ;//    +  ACE
  AceCount         dw  0  ;// - ACE  ACL
  Sbz2             dw  0  ;//    32-
ends

struct ACE_HEADER
  AceType          db  0  ;// 
  AceFlags         db  0  ;//
  AceSize          dw  0  ;//
ends

struct ACCESS_ALLOWED_ACE
  AceType          db  0  ;// 
  AceFlags         db  0  ;//
  AceSize          dw  0  ;//
  Mask             dd  0  ;//
  SidStart         dd  0  ;// 
ends

struct SECURITY_DESCRIPTOR
  Revision     db  0   ;//  
  Sbz1         db  0   ;// ( )
  Control      dw  0   ;// "SECURITY_DESCRIPTOR_CONTROL"
  Owner        dd  0   ;//   SID 
  Group        dd  0   ;//   SID 
  Sacl         dd  0   ;//   "ACE_HEADER"
  Dacl         dd  0   ;//   "DACL_HEADER"
ends

struct LUID
  LowPart          dd  0
  HighPart         dd  0
ends

struct TOKEN_GROUPS
  GroupCount        dd  0
  Groups            SID_AND_ATTRIBUTES
ends

struct TOKEN_PRIVILEGES
  PrivilegeCount    dd  0
  Privileges        LUID_AND_ATTRIBUTES
ends

struct TOKEN_SOURCE
  SourceName        dq  0     ;// 8 byte char
  SourceIdentifier  dd  0     ;// LUID
ends

struct SEP_TOKEN_PRIVILEGES
  Present           dq  0
  Enabled           dq  0
  EnabledByDefault  dq  0
ends

struct QUOTA_LIMITS  ;//<----     =  
  PagedPoolLimit     dd  0
  NonPagedPoolLimit  dd  0
  MinWorkingSetSize  dd  0
  MaxWorkingSetSize  dd  0
  PagefileLimit      dd  0
  TimeLimit          dd  0
ends

struct TOKEN_GROUPS_AND_PRIVILEGES
  SidCount                dd  0
  SidLength               dd  0
  Sids                    dd  0      ;//    PSID_AND_ATTRIBUTES  
  RestrictedSidCount      dd  0      ;// 
  RestrictedSidLength     dd  0 
  RestrictedSids          dd  0      ;// PSID_AND_ATTRIBUTES  
  PrivilegeCount          dd  0
  PrivilegeLength         dd  0
  Privileges              dd  0      ;// PLUID_AND_ATTRIBUTES 
  AuthenticationId        dd  0      ;// LUID 
ends

struct TOKEN_STATISTICS
  TokenId                 dd  0    ;//  LUID 
  AuthenticationId        dd  0    ;// LUID,    
  ExpirationTime          dd  0    ;//     ( )
  TokenType               dd  0    ;// TOKEN_PRIMARY(1), TOKEN_IMPERSONATION(2) = 
  ImpersonationLevel      dd  0    ;//   
  DynamicCharged          dd  0    ;//    ,      
  DynamicAvailable        dd  0    ;// -  
  GroupCount              dd  0    ;// - . SID
  PrivilegeCount          dd  0    ;// -   
  ModifiedId              dd  0    ;//   
ends

struct TOKEN_ACCESS_INFORMATION 
  SidHash                 dd  0
  RestrictedSidHash       dd  0
  Privileges              dd  0
  AuthenticationId        dd  0
  TokenType               dd  0
  ImpersonationLevel      dd  0
  MandatoryPolicy         dd  0
  Flags                   dd  0
  AppContainerNumber      dd  0
  PackageSid              dd  0
  CapabilitiesHash        dd  0
  TrustLevelSid           dd  0
  SecurityAttributes      dd  0
ends

struct PROFILEINFOA
  dwSize           dd  sizeof.PROFILEINFOA
  dwFlags          dd  0
  lpUserName       dd  0
  lpProfilePath    dd  0
  lpDefaultPath    dd  0
  lpServerName     dd  0
  lpPolicyPath     dd  0
  hProfile         dd  0
ends












